/*
    FreeRTOS V9.0.0 - Copyright (C) 2016 Real Time Engineers Ltd.
    All rights reserved

    VISIT http://www.FreeRTOS.org TO ENSURE YOU ARE USING THE LATEST VERSION.

    This file is part of the FreeRTOS distribution.

    FreeRTOS is free software; you can redistribute it and/or modify it under
    the terms of the GNU General Public License (version 2) as published by the
    Free Software Foundation >>>> AND MODIFIED BY <<<< the FreeRTOS exception.

    ***************************************************************************
    >>!   NOTE: The modification to the GPL is included to allow you to     !<<
    >>!   distribute a combined work that includes FreeRTOS without being   !<<
    >>!   obliged to provide the source code for proprietary components     !<<
    >>!   outside of the FreeRTOS kernel.                                   !<<
    ***************************************************************************

    FreeRTOS is distributed in the hope that it will be useful, but WITHOUT ANY
    WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
    FOR A PARTICULAR PURPOSE.  Full license text is available on the following
    link: http://www.freertos.org/a00114.html

    ***************************************************************************
     *                                                                       *
     *    FreeRTOS provides completely free yet professionally developed,    *
     *    robust, strictly quality controlled, supported, and cross          *
     *    platform software that is more than just the market leader, it     *
     *    is the industry's de facto standard.                               *
     *                                                                       *
     *    Help yourself get started quickly while simultaneously helping     *
     *    to support the FreeRTOS project by purchasing a FreeRTOS           *
     *    tutorial book, reference manual, or both:                          *
     *    http://www.FreeRTOS.org/Documentation                              *
     *                                                                       *
    ***************************************************************************

    http://www.FreeRTOS.org/FAQHelp.html - Having a problem?  Start by reading
    the FAQ page "My application does not run, what could be wrong?".  Have you
    defined configASSERT()?

    http://www.FreeRTOS.org/support - In return for receiving this top quality
    embedded software for free we request you assist our global community by
    participating in the support forum.

    http://www.FreeRTOS.org/training - Investing in training allows your team to
    be as productive as possible as early as possible.  Now you can receive
    FreeRTOS training directly from Richard Barry, CEO of Real Time Engineers
    Ltd, and the world's leading authority on the world's leading RTOS.

    http://www.FreeRTOS.org/plus - A selection of FreeRTOS ecosystem products,
    including FreeRTOS+Trace - an indispensable productivity tool, a DOS
    compatible FAT file system, and our tiny thread aware UDP/IP stack.

    http://www.FreeRTOS.org/labs - Where new FreeRTOS products go to incubate.
    Come and try FreeRTOS+TCP, our new open source TCP/IP stack for FreeRTOS.

    http://www.OpenRTOS.com - Real Time Engineers ltd. license FreeRTOS to High
    Integrity Systems ltd. to sell under the OpenRTOS brand.  Low cost OpenRTOS
    licenses offer ticketed support, indemnification and commercial middleware.

    http://www.SafeRTOS.com - High Integrity Systems also provide a safety
    engineered and independently SIL3 certified version for use in safety and
    mission critical applications that require provable dependability.

    1 tab == 4 spaces!
*/


#ifndef FREERTOS_CONFIG_H
#define FREERTOS_CONFIG_H

/*-----------------------------------------------------------
 * Application specific definitions.
 *
 * These definitions should be adjusted for your particular hardware and
 * application requirements.
 *
 * THESE PARAMETERS ARE DESCRIBED WITHIN THE 'CONFIGURATION' SECTION OF THE
 * FreeRTOS API DOCUMENTATION AVAILABLE ON THE FreeRTOS.org WEB SITE.
 *
 * See http://www.freertos.org/a00110.html.
 *----------------------------------------------------------*/


/* Ensure stdint is only used by the compiler, and not the assembler. */
#ifdef __ICCARM__
	#include <stdint.h>
	extern uint32_t SystemCoreClock;
#endif
#include "stm32f0xx.h"

#define configUSE_PREEMPTION			1																										/* Ƿóȶںˣ1ʱȼߵִС Ϊ0ûȼ֮˵ʱƬִ */
#define configUSE_IDLE_HOOK				0																										/* IDLEHOOKOSչҪԼӦ void vApplicationIdleHook( void ) */
#define configUSE_TICK_HOOK				0																										/* SYSTEM TICKHOOKOSչҪԼӦ  void vApplicationTickHook(void ) */
#define configCPU_CLOCK_HZ				( SystemCoreClock )																	/* ϵͳCPUƵʣλHz */
#define configTICK_RATE_HZ				( ( TickType_t ) 1000 )															/* ϵͳSYSTEM TICKÿӵķ ֵԽϵͳӦԽ죬CPUлĿԽ */
#define configMAX_PRIORITIES			( 5 )																								/* ϵͳȼ5 ˵5ȶȡĿԽķRAMԽ */
#define configMINIMAL_STACK_SIZE		( ( unsigned short ) 60 )													/* ϵͳСջߴ磬ע128128ֽڣ128ջARM32λ128ջ512ֽ */ 
#define configTOTAL_HEAP_SIZE			( ( size_t ) ( 2500 ) )															/* ϵͳڴ档һɳ˲ϵͳĳRAMRAM 20KRAM2Kϵͳ3Kʣ15HEAP ߴ硣СȻ󿴱*/
#define configMAX_TASK_NAME_LEN			( 16 )																						/* PC󳤶ȣΪ˾Ͳˣ׷ʱ֪ĸ֡16ʾ16char */
#define configUSE_TRACE_FACILITY		1																									/* Ƿ趨׷٣PCTraceCon.exe¼Ҳתϵͳʾ */
#define configUSE_16_BIT_TICKS			0																									/* SYSTEM TICKĳȣ1616λ16λCPU һѡ132λϵͳһѡ0 */
#define configIDLE_SHOULD_YIELD			1																									/* лǿʹܣǰִ֮ʣʱƬǿԼʣʱƬȻִлȥִ*/
#define configUSE_MUTEXES				1																											/* ǷMUTEXES MUTEXESͨѶһַʽرԴӦãӡAõʱųӦã˱ſӦ */
#define configQUEUE_REGISTRY_SIZE		8																									/* עãöڵ֧֣1.һ֣ʱĸС		2.ҪضϢλкź		ĵûܣĸעͺôռõıRAMռ䡣 */
#define configCHECK_FOR_STACK_OVERFLOW	0																							/* DEBUGǷջҪԼӦ麯void vApplicationStackOverflowHook(xTaskHandle *pxTask, signed portCHAR *pcTaskName )  */
#define configUSE_RECURSIVE_MUTEXES		1																								/*  ȷǷõݹʽMUTEXES */
#define configUSE_MALLOC_FAILED_HOOK	0																								/* ÿһ񡢶СźʱںʹһΪpvPortMalloc()ĺӶзڴ档 */
#define configUSE_APPLICATION_TASK_TAG	0																							/* ΪÿǩֵֵӦóʹãں˱ʹ RTOS trace macrosĵṩһܺõӡӦóص㡣  */
#define configUSE_COUNTING_SEMAPHORES	1																								/* ó1ʾʹüźó0ʾʹá */
#define configGENERATE_RUN_TIME_STATS	0																								/* Ϊ1ʹʱͳƹܡ */

/* Run time and task stats gathering related definitions. */ 
//#define configGENERATE_RUN_TIME_STATS                1 
//#define configUSE_STATS_FORMATTING_FUNCTIONS         1 
//#define portCONFIGURE_TIMER_FOR_RUN_TIME_STATS()     (ulHighFrequencyTimerTicks = 0ul) 
//#define portGET_RUN_TIME_COUNTER_VALUE()             ulHighFrequencyTimerTicks 
//#define portALT_GET_RUN_TIME_COUNTER_VALUE           1 

/* Co-routine definitions. */
#define configUSE_CO_ROUTINES 			0																									/* ʹЭ̡Э̹öջʡRAMûȼߣҲ޷ͨѶ */
#define configMAX_CO_ROUTINE_PRIORITIES ( 2 )																					/* Э̵ȼЭȼԶ񡣾ϵͳִִ˲ִЭ̡*/

/* Software timer definitions. */
#define configUSE_TIMERS				1																											/* Ϊ1ʱܡ */
#define configTIMER_TASK_PRIORITY		( 2 )																							/* ʱȼ */
#define configTIMER_QUEUE_LENGTH		5																									/* ʱõеĳȡ */
#define configTIMER_TASK_STACK_DEPTH	( 80 )																					/* ʱҪջС */

/* Set the following definitions to 1 to include the API function, or zero
to exclude the API function. */
#define INCLUDE_vTaskPrioritySet		1																									/* 趨Ըıȶ */
#define INCLUDE_uxTaskPriorityGet		1																									/* 趨Բѯȶ */
#define INCLUDE_vTaskDelete				1																										/* 趨ɾ */
#define INCLUDE_vTaskCleanUpResources	1																								/* ˵ǿԻɾԴRAMȣ*/
#define INCLUDE_vTaskSuspend			1																										/* ÿ԰ */
//#define INCLUDE_vResumeFromISR		1 																									/* ÿԴжϻָϵͳ˯ߣжϻ */
#define INCLUDE_vTaskDelayUntil			1																									/* ӳٵľʱ䣬430ӳٵ500ʱ䶼Ǿʱ */
#define INCLUDE_vTaskDelay				1																										/* ʱӳ30ӣԵʱ䣬ʲôʱ䣬Ҫ֪ */
//#define INCLUDE_xTaskGetSchedulerState		1																						/*  ȡõǰ״̬ */
//#define INCLUDE_xTaskGetCurrentTaskHandle		1																					/* õǰĸ */
//#define INCLUDE_uxTaskGetStackHighWaterMark		0 																			/* ǷʹһĿǷִкջСδͬΪֹջ */


/* Normal assert() semantics without relying on the provision of an assert.h
header file. */
#define configASSERT( x ) if( ( x ) == 0 ) { taskDISABLE_INTERRUPTS(); for( ;; ); }

/* Definitions that map the FreeRTOS port interrupt handlers to their CMSIS
standard names - or at least those used in the unmodified vector table. */
#define vPortSVCHandler SVC_Handler
#define xPortPendSVHandler PendSV_Handler
#define xPortSysTickHandler SysTick_Handler

#endif /* FREERTOS_CONFIG_H */

